input {
      beats {
        port => "5000"
        codec => "json"

    }
}

## Add your filters / logstash plugins configuration here

filter{
    if ([fields][log_type] =="WSO2")
    {
        if [message] =~ "CarbonCoreActivator" {
         grok {
             match => { "message" => "\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{GREEDYDATA:tenant_id}\] \[] \[%{GREEDYDATA:thread}\]  %{LOGLEVEL:loglevel} \{%{GREEDYDATA:class}\} - %{GREEDYDATA:key} : %{GREEDYDATA:value}" }
             }
        } else if [message] =~ "ERROR" {
         grok {
             match => { "message" => "\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{GREEDYDATA:tenant_id}\] \[] \[%{GREEDYDATA:thread}\] %{LOGLEVEL:loglevel} \{%{GREEDYDATA:error_generator}\} -  %{GREEDYDATA:error_message}" }
         }
        } else if [message] =~ "logged" {
         grok {
             match => { "message" => "\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{GREEDYDATA:tenant_id}\] \[] \[%{GREEDYDATA:thread}\]  %{LOGLEVEL:loglevel} \{%{GREEDYDATA:class}\} -  \'%{GREEDYDATA:user} \[%{GREEDYDATA:tenant_id}\]\' %{GREEDYDATA:action} at \[%{TIMESTAMP_ISO8601:actiontime}\]"}
         }
        } else{
           grok {
             match => { "message" => "\[%{TIMESTAMP_ISO8601:timestamp}\] \[%{GREEDYDATA:tenant_id}\] \[] \[%{GREEDYDATA:thread}\]  %{LOGLEVEL:loglevel} \{%{GREEDYDATA:class}\} -  %{GREEDYDATA:EffectiveMessage}"}
         }
        }
    }
    else if ([fields][log_type] =="CUSTOM"){
        json{
            source => "message"
        }
        if ([startStop] == "STOP"){

        date {
             match => ["messageStartTimeStamp" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "messageStartTimeStamp"
             locale => "en"

        }
        date {
             match => ["sequenceStartTime" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "sequenceStartTime"
             locale => "en"

        }
        date {
             match => ["sequenceEndTime" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "@timestamp"
             add_field => { "debug" => "timestampMatched"}
             locale => "en"
        }
        date {
             match => ["sequenceEndTime" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "sequenceEndTime"
             locale => "en"
        }
    }
    else if ([startStop] == "START"){
        date {
             match => ["messageStartTimeStamp" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "messageStartTimeStamp"
             locale => "en"

        }
        date {
             match => ["sequenceStartTime" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "@timestamp"
             add_field => { "debug" => "timestampMatched"}
             locale => "en"
        }
        date {
             match => ["sequenceStartTime" , "yyyy-MM-dd HH:mm:ss.SSS"]
             target => "sequenceStartTime"
             locale => "en"
        }
        }
    }
    
    mutate {
        add_field => { "[@metadata][lc_identifier]" => "%{[fields][Customer]}-%{[fields][Environment]}" }
        }
        mutate {
        lowercase => [ "[@metadata][lc_identifier]" ]
        }
    
}




output {
        elasticsearch {
            hosts    => [ 'elasticsearch' ]
            user     => 'elastic'
            password => "${ELASTIC_PASSWORD}"  # read password from logstash.keystore
            ssl => true
            cacert => '/usr/share/logstash/config/certs/ca/ca.crt'
            index => "wso2-%{[@metadata][lc_identifier]}-%{+YYYY.MM.dd}"
        }
    stdout {
     codec => rubydebug
    }
}
